#coding = utf-8
from Crypto.Cipher import AES
import base64
import requests
import json
import binascii
import os
import sys
import urllib.request

FAKE_HEADERS = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',  # noqa
    'Accept-Charset': 'UTF-8,*;q=0.5',
    'Accept-Encoding': 'gzip,deflate,sdch',
    'Accept-Language': 'en-US,en;q=0.8',
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0',  # noqa
    'referer': 'https://www.google.com'
}

def encode_netease_data(data) -> str:
    data = json.dumps(data)
    key = binascii.unhexlify('7246674226682325323F5E6544673A51')
    encryptor = AES.new(key, AES.MODE_ECB)
    # 补足data长度，使其是16的倍数
    pad = 16 - len(data) % 16
    fix = chr(pad) * pad
    byte_data = (data + fix).encode('utf-8')
    return binascii.hexlify(encryptor.encrypt(byte_data)).upper().decode()

def netease_search(keyword) -> list:
    count = 8
    eparams = {
        'method': 'POST',
        'url': 'http://music.163.com/api/cloudsearch/pc',
        'params': {
            's': keyword,
            'type': 1,
            'offset': 0,
            'limit': count
        }
    }
    data = {'eparams': encode_netease_data(eparams)}

    s = requests.Session()
    s.headers.update(FAKE_HEADERS)
    s.headers.update({
        'referer': 'http://music.163.com/',
    })

    r = s.post('http://music.163.com/api/linux/forward', data=data)

    if r.status_code != requests.codes.ok:
        raise RequestError(r.text)
    j = r.json()
    if j['code'] != 200:
        raise ResponseError(j)
    return j

def GetSongUrl(songname):
    songlist = netease_search(songname)['result']['songs']
    x = songlist[0]
    url = 'http://music.163.com/song/media/outer/url?id=' + str(x['id']) + '.mp3'
    artists = ''
    for i in range(len(x['ar'])):
        if i != 0:
            artists += ('&'+ x['ar'][i]['name'])
        else:
            artists += x['ar'][i]['name']
    return url,artists #url是歌曲的链接，artists是歌手名字

if __name__ == "__main__":
    text = sys.argv[1]
    url,artlists = GetSongUrl(text)
    print(GetSongUrl(text))
    os.system("mplayer " + url)

